#include "bits/stdc++.h"

typedef unsigned long long ull;

struct FastMod {
    ull b, m;

    FastMod(ull b) : b(b), m(-1ULL / b) {}

    ull reduce(ull a) {
        return a - (ull) ((__uint128_t(m) * a) >> 64) * b;
    }
};

int main() {
//    ull a,b;
//    std::cin >> a >> b;
//
//    FastMod fastMod(b);
//    std::cout << fastMod.reduce(a) << std::endl;
//    return 0;
    std::cin.tie(0)->sync_with_stdio(0);
    std::cin.exceptions(std::cin.failbit);

    int N;
    std::cin >> N;

    std::vector<int> nums(N);
    for (int i = 0; i < N; ++i) {
        std::cin >> nums[i];
    }

    int Q;
    std::cin >> Q;

    for (int q = 0; q < Q; ++q) {
        int s, t;
        ull k;
        std::cin >> s >> t >> k;
        s--;
        t--;

        FastMod fastMod(k);

        ull product = 1;
        for (int i = s; i <= t; ++i) {
            product *= nums[i];
            product %= k;
            product = fastMod.reduce(product);

            if (product == 0 || product == k) {
                std::cout << "Yes" << std::endl;
                break;
            }
        }
        if (product != 0) {
            std::cout << "No" << std::endl;
        }
    }


    return 0;
}
